/*
    Copyright (C) 1998 Lars Knoll (knoll@mpi-hd.mpg.de)
    Copyright (C) 2001 Dirk Mueller <mueller@kde.org>
    Copyright (C) 2006 Samuel Weinig (sam.weinig@gmail.com)
    Copyright (C) 2004, 2005, 2006, 2007, 2008 Apple Inc. All rights reserved.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.

    This class provides all functionality needed for loading images, style sheets and html
    pages from the web. It has a memory cache for these objects.
*/

#pragma once

#include "CachedResource.h"
#include "SourceProviderCache.h"

namespace WebCore {

class CachedResourceLoader;
class TextResourceDecoder;

class CachedScript FINAL : public CachedResource {
public:
	CachedScript(CachedResourceRequest&);
	virtual ~CachedScript();

    StringView script();
    unsigned scriptHash();

	PassRefPtr<JSC::SourceProviderCache> getSourceProviderCache() { return m_sourceProviderCache; }
	void setSourceProviderCache(PassRefPtr<JSC::SourceProviderCache>);

private:
	virtual void setEncoding(const String&) FINAL;
	virtual String encoding() const FINAL;
	virtual const TextResourceDecoder* textResourceDecoder() const override { return m_decoder.get(); }
	virtual void finishLoading(SharedBuffer*) FINAL;

    virtual void handleOutOfMemory(bool clearRawData) FINAL;
	virtual void destroyDecodedData() FINAL;

	virtual void setBodyDataFrom(const CachedResource&) FINAL;

    virtual bool mayTryReplaceEncodedData() const OVERRIDE { return true; }

	String m_script;
    unsigned m_scriptHash;

    enum DecodingState { NeverDecoded, DataAndDecodedStringHaveSameBytes, DataAndDecodedStringHaveDifferentBytes };
    DecodingState m_decodingState;

    RefPtr<JSC::SourceProviderCache> m_sourceProviderCache;
	RefPtr<TextResourceDecoder> m_decoder;
};
}
